{
  config,
  pkgs,
  lib,
  ...
}: {
  environment.systemPackages = with pkgs; [
    colmena
    dig
    eza
    git
    htop
    screen
    tcpdump
  ];

  environment.shellAliases = {
    l = "eza -lah --git --git-repos-no-status";
  };

  programs.mosh.enable = !(builtins.elem config.networking.hostName []);
  programs.mtr.enable = true;

  programs.vim.defaultEditor = true;
}
