{ lib, config, pkgs, ...}:
let
  inherit (config.retronix.retroarch) mapRetroarchConfig;
  mkFile = name: path: pkgs.runCommand name {} ''
    mkdir -p $out
    cp ${path} $out/${name}
    '';
in
{
  retronix = {
    systems = {
      "arcade" = {
        extension = ".sh";
        games = with pkgs.roms; mapRetroarchConfig {} [
          atetris
          dkong
          mario
          neopong
          pacman
          spacedx
        ];
      };
    };
    emulationstation = {
      inputCfgFile = mkFile "es_input.cfg" ./es-config/es_input.cfg;
      settingsCfgFile = mkFile "es_settings.cfg" ./es-config/es_settings.cfg;
      themes = {
        "ComicBook" = pkgs.fetchFromGitHub {
          owner = "TMNTturtleguy";
          repo = "es-theme-ComicBook";
          rev = "master";
          hash = "sha256-Mma7/5osIvTdTM8Z0vkJBW/4p3O6wms6nBApxB7+IiA=";
        };
      };
    };
  };
}
